C
C      Diagonal matrix for Double-Double precision
C
       subroutine ddmatrix_diagonal(n, ah, al, wh,wl)
       implicit double precision(a-h,o-z),integer(i-n)
       real(8)   :: ah(n,n), al(n,n)
       real(8)   :: wh(n), wl(n)

       real(8)   :: temp_h, temp_l
       real(16)  :: qtmp, qtmph, qtmpl

       do i=1,n
          do j=1,n
             if(i == j) then
               CALL RANDOM_NUMBER(qtmp)
               tmph = qtmp
               qtmph = tmph
               qtmpl = qtmp - qtmph
               tmpl = qtmpl
               ah(i,j)=qtmph
               al(i,j)=qtmpl
	       wh(i)=ah(i,j)
               wl(i)=al(i,j)
             else
               ah(i,j)=0.0
               al(i,j)=0.0
             end if
          enddo
       enddo

       return
       end
